// pages/messageCenter/messageCenter.js
const miucms = require('../../utils/miucms.js')
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        list: [],
        page: 1,
        issubscribe: 1,
        qrcode: "",
        count: 0,
        popupState: false,
        officialLoadState: false, // 关注服务号组件的加载状态
        operationsTop: false,
        screen_data: {},
        wechat: {},

        gtergreenonionqrcode: miucms.gtergreenonionqrcode,

        consultState: false,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.getList()

        let screen_data = app.globalData.screen_data
        let wechat = app.globalData.wechat
        let totalTopHeight = screen_data.totalTopHeight
        let windowWidth = screen_data['windowWidth']; //获取设备屏幕宽度
        let headHeight = (windowWidth / 750) * Number(450)
        this.headHeight = headHeight - totalTopHeight

        this.setData({
            wechat
        })

        app.globalData.unreadMessages = 0
        app.globalData.unreadMessagesState = true
    },
    headHeight: 0,
    onPageScroll(e) {
        if (e.scrollTop > this.headHeight && !this.data.operationsTop) {
            this.setData({
                operationsTop: true
            })
        } else if (e.scrollTop <= this.headHeight && this.data.operationsTop) {
            this.setData({
                operationsTop: false
            })
        }

    },
    getList() {
        if (this.data.page == 0) return

        wx.showLoading({
            title: '加载中...',
        })
        miucms.request(app.globalData.baseURL + "/tenement/message/lists", {
            page: this.data.page
        }).then(res => {
            wx.hideLoading()
            if (res.code == 200) {
                let data = res.data
                data.data && data.data.forEach(element => {
                    element.message = element.message.trim()
                });

                // console.log("data", data.data);
                // data.data[0].event = "certapplication"
                // data.data[0].data[]
                this.setData({
                    list: this.data.list.concat(data.data),
                    page: data.count > data.page * data.limit ? this.data.page + 1 : 0,
                    issubscribe: data.issubscribe,
                    qrcode: data.qrcode,
                    count: data.count,
                })
            } else {
                wx.showModal({
                    title: '提示',
                    content: res.message
                })
            }
        }).catch(err => {
            wx.hideLoading()
        })
    },


    // 点击关注
    attention() {
        this.setData({
            popupState: !this.data.popupState
        })
    },

    // 点击标题跳转
    jumpDetails(e) {
        let uniqid = e.currentTarget.dataset.uniqid
        let tenementcertifiedstatus = e.currentTarget.dataset.tenementcertifiedstatus

        // if (tenementcertifiedstatus == 0) {
        //     wx.navigateTo({
        //         url: `/pages/user/user?tab=publish`,
        //     })
        //     return
        // }

        wx.navigateTo({
            url: `/pages/show/show?uniqid=${uniqid}`,
        })
    },

    // 跳转我的-发布
    jumpUserPost() {
        wx.navigateTo({
            url: `/pages/user/user?tab=publish`,
        })
    },

    cutConsultState() {
        this.setData({
            consultState: !this.data.consultState,
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {
        this.setData({
            list: [],
            page: 1,
            issubscribe: 1,
            qrcode: '',
            count: 0
        })
        wx.stopPullDownRefresh();

        this.getList()
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        this.getList()
    },

    copy(e) {
        miucms.copy(this.data.wechat.wechat)
    },

    // 公共跳转
    publicJumps(e) {
        let url = e.currentTarget.dataset.url
        wx.navigateTo({
            url: `/pages/webViewwebweb/index?url=${ url }`,
        })
    },
})