// pages/search/search.js
var app = getApp()
var config = {};
var miucms = require('../../utils/miucms.js');
Page({
    /**
     * 页面的初始数据
     */
    data: {
        isloding: true,
        showTOTOP: false,
        kw: '',
        log: [],
        hot: [],
        focus: false,
        list: [],
        search: false,
        loading: false,
        complete: false,
        status: 0,
        q: '',
        options: {},
        // tab: 'hongkongrental',
        tab: 'personal', // personal  intermediary    studentapartment
        tabList: {
            personal: "个人房源",
            intermediary: "中介房源",
            studentapartment: "学生公寓",
        },
        otherrental: {
            page: {
                next_page: 1
            },
            list: [],
            loading: false
        },
        hongkongrental: {
            page: {
                next_page: 1
            },
            list: [],
            loading: false
        },
        studentapartment: {
            page: {
                next_page: 1
            },
            list: [],
            loading: false
        },
        screen_data: {},

        personal: {
            data: [],
            page: 1,
            count: 0,
            searchid: ""
        },
        intermediary: {
            data: [],
            page: 1,
            count: 0,
            searchid: ""
        },
        studentapartment: {
            data: [],
            page: 1,
            count: 0,
            searchid: ""
        },
        langs: {}, // 语言包数据

        asking: {
            data: [],
            page: 1
        },

        resultListLoad: false, // 搜索结果请求中状态
        location: {
            value: [],
            data: null
        },

        types: {
            value: '',
            data: null
        }, //6.24删除
        school: {
            list: {},
            value: ''
        },

        isUpdateData: false, // 是否需要更新数据
        operationstype: "personhousing", // 筛选的 类型值   personhousing  intermediaryhousing  student
        operationstypeObj: {
            personal: "personhousing",
            intermediary: "intermediaryhousing",
            studentapartment: "student",
            asking: "askinghousing",
        },

        brands: {
            list: [],
            value: '',
            obj: {}
        },
        roomlistings: {
            list: [],
            value: '',
            obj: {}
        },
        roomtype: {
            list: [],
            value: '',
            obj: {}
        },

        operationsTop: false, // 操作栏 是否在顶部


        isAskingSearch: true, // 是否是 求房源的搜索

        isMapFindState: false,

    },

    operationsHeight: 50,

    onPageScroll(e) {
        if (e.scrollTop > 1000 && !this.data.showTOTOP) {
            this.setData({
                showTOTOP: true
            })
        } else if (e.scrollTop < 1000 && this.data.showTOTOP) {
            this.setData({
                showTOTOP: false
            })
        }

        if (e.scrollTop > this.operationsHeight && !this.data.operationsTop) {
            this.setData({
                operationsTop: true
            })
        } else if (e.scrollTop <= this.operationsHeight && this.data.operationsTop) {
            this.setData({
                operationsTop: false
            })
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        var that = this;
        let isAskingSearch = options['isAskingSearch'] || false
        let operationstype = "personhousing"
        if (isAskingSearch) operationstype = "askinghousing"
        this.setData({
            focus: options.kw ? false : true,
            kw: options.kw || '',
            // tab: options.tab || 'hongkongrental'
            tab: options.tab || 'personal',
            isAskingSearch,
            operationstype,
        })

        this.get_config()
        wx.getStorage({
            key: 'searchHistoryList',
            success: function (res) {
                that.setData({
                    log: res.data || []
                })
            },
        })

    },
    get_config() {
        var that = this;
        if (app.globalData.config.lists) {
            config = app.globalData.config;
            that.setData({
                isMapFindState: app.globalData.isMapFindState,
                status: app.globalData.status,
                screen_data: app.globalData.screen_data,
                langs: app.globalData.langs,
            })

            let screen_data = this.data.screen_data
            let totalTopHeight = screen_data['totalTopHeight']
            this.operationsHeight = totalTopHeight

            that.get_content()
            this.getLocationList()
            this.getfilterConditions()
            app.globalData['langs'] ? '' : this.getDtailsLangs()

            if (that.data.kw.trim().length > 0) that.submit()
        } else {
            setTimeout(function () {
                that.get_config()
            }, 200)
        }
    },

    // 获取语言包 保存全局
    getDtailsLangs() {
        miucms.request(`${app.globalData.baseURL}/tenement/v2/api/details/langs`).then(res => {
            if (res.code != 200) return
            let data = res.data
            this.setData({
                langs: data
            })
            app.globalData['langs'] = data
        })
    },

    // 专门梳理v4出现的 语音包 及 不同房源值的处理
    handleDetailData(data) {
        let langs = this.data.langs || {}
        if (Object.keys(langs).length == 0) {
            setTimeout(() => {
                this.handleDetailData(data)
            }, 300)
        } else {
            let tab = this.data.tab
            data.forEach(ele => {
                // 这个是将 详情键 替换语言包里的值
                let list = ['type', 'rentalduration', 'intermediary', "property", "elevator", "sunshinearea", "gender", "publishergender"]
                if (Array.isArray(ele['floor'])) list.push('floor') //  判断 楼层是否需要 替换值, 因为在求房源里是多个值
                let differentNames = { // 需要替换的 键名
                    "intermediary": "intermediary_text"
                }

                if (Array.isArray(ele.rent)) ele.rent = ele.rent.join(' ~ ')

                list.forEach(element => {
                    if (ele[element] == -1) {} else if (ele[element] == 0) ele[differentNames[element] ? differentNames[element] : element] = '不限' //  当 值为 [0] 时为不限
                    else ele[differentNames[element] ? differentNames[element] : element] = langs[element == 'publishergender' ? 'gender' : element][ele[element]]
                })
                let tabArr = ["gptype", "type", "elevator", "sunshinearea", "gender"]
                let tabList = []
                tabArr.forEach(el => {
                    if (ele[el] && ele[el] != -1 && ele[el] != "不限") tabList.push(ele[el])
                })
                ele['tabList'] = tabList
                let location = langs.location // 遍历替换区域的值  所有房源
                let pendingData = ele['location']

                if (Array.isArray(pendingData)) {
                    let locationList = []
                    for (const key in location) {
                        if (pendingData.indexOf(key) != -1 && Math.trunc(key) != key) locationList.push(`${location[Math.trunc(key)]} > ${location[key]}`)
                    }
                    ele['locationList'] = locationList
                } else if (location[pendingData]) ele['location'] = `${location[Math.trunc(pendingData)]}  >  ${location[pendingData]}`
            })
            let tabData = this.data[this.data.isAskingSearch ? 'asking' : tab]["list"] || []
            tabData = tabData.concat(data)
            this.setData({
                [`${this.data.isAskingSearch ?  'asking' : tab}.list`]: tabData,
            })
        }
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        if (!app.globalData.config.lists || !this.data.search) return false

        if (this.data.isAskingSearch) {
            this.askingHousingSearch()
        } else {
            this.getResultList()
        }
        // this.getResultList()
    },
    cancle() {
        var pages = getCurrentPages();
        if (pages.length == 1) {
            wx.reLaunch({
                url: `/pages/index/index`
            });
        } else wx.navigateBack(); //返回上一页

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {
        const that = this;
        let url = `/pages/search/search?kw=${that.data.kw}&tab=${that.data.tab}`;
        return {
            path: url,
            title: app.globalData.topTitle,
        }
    },
    onShareTimeline() {
        let url = `/pages/search/search?kw=${this.data.kw}&tab=${this.data.tab}`;
        return {
            path: url,
            title: app.globalData.topTitle,
        }
    },

    input: function (e) {
        this.setData({
            kw: e.detail.value
        })
    },
    // 提交
    submit: function () {
        // this.data.kw = this.data.kw.trim();
        if (this.data.kw == '') {
            wx.showToast({
                title: '请输入内容~',
                icon: 'none'
            })
            return false
        }
        if (this.data.log.indexOf(this.data.kw) == -1) {
            // 未存在历史记录列表中
            this.data.log.unshift(this.data.kw)
            // 最多存10条内容
            if (this.data.log.length > 10) {
                this.data.log.length = 10
            }
            this.setData({
                log: this.data.log
            })
            wx.setStorage({
                key: 'searchHistoryList',
                data: this.data.log,
            })
        }
        if (this.data.isAskingSearch) {
            this.data.asking = {
                data: [],
                page: 1
            }
            this.askingHousingSearch()
        }

        this.clearAllData()
        this.clear_list()
    },
    // 清空历史记录
    clear_keywords: function () {
        let that = this;
        wx.showModal({
            title: '提示',
            content: '确定删除全部记录？',
            confirmColor: '#bc322f',
            success: function (res) {
                if (res.confirm === true) {
                    if (!app.globalData.config || !app.globalData.config.lists) {
                        return false
                    }
                    miucms.request(app.globalData.config.lists.removesearchlog, {}).then(data => {

                        if (data.extraparam.mode == 'right') {
                            that.setData({
                                log: []
                            })
                            wx.setStorage({
                                key: 'searchHistoryList',
                                data: [],
                            })
                        }
                    })

                }
            }
        })

    },
    // 获取热词
    get_content: function () {
        var that = this;
        var sendData = Object.assign({}, this.data.options, {
            session: wx.getStorageSync('session'),
        })
        miucms.request(app.globalData.config.lists.search, {}).then(data => {
            that.setData({
                hot: data.hot,
                isloding: false
            })
        }).catch(res => {})

    },
    // 点击热词或者历史记录item
    select_kw: function (e) {
        wx.pageScrollTo({
            scrollTop: 0,
            duration: 200,
        })
        var kw = e.currentTarget.dataset.kw;
        this.setData({
            kw
        })
        this.clearAllData()
        app.globalData.kw = kw;
        this.clear_list()
    },
    clearAllData() {
        // 清空所有数据
        this.setData({
            otherrental: {
                page: {
                    next_page: 1
                },
                list: [],
                loading: false
            },
            hongkongrental: {
                page: {
                    next_page: 1
                },
                list: [],
                loading: false
            },
            studentapartment: {
                page: {
                    next_page: 1
                },
                list: [],
                loading: false
            }
        })
    },
    // 清空list
    clear_list: function () {
        let tab = this.data.tab;
        this.data[tab] = {
            page: {
                next_page: 1
            },
            list: [],
            loading: false
        }
        this.setTabData()
        this.searchKW()

        // miucms.statistics({
        //     name: "search",
        //     data: {
        //         kw: this.data.kw,
        //     }
        // })
    },
    setTabData() {
        let tab = this.data.tab;
        switch (tab) {
            case 'otherrental':
                this.setData({
                    otherrental: this.data.otherrental
                })
                break;
            case 'studentapartment':
                this.setData({
                    studentapartment: this.data.studentapartment
                })
                break;
            case 'hongkongrental':
                this.setData({
                    hongkongrental: this.data.hongkongrental
                })
                break;
        }
    },
    searchdata: '',
    // 搜索关键词
    searchKW: function () {
        var that = this;
        if (!app.globalData.config.search) return false

        this.setData({
            loading: true
        })
        miucms.request(app.globalData.config.search.global, {
            // miucms.request(`${app.globalData.baseURL}/tenement/housingresources/lists`, {
            'keyword': this.data.kw
        }).then(data => {
            if (data.code != 200) {
                wx.showToast({
                    title: data.message,
                    icon: 'none'
                })

                that.setData({
                    loading: false,
                    otherrental: {
                        page: {
                            next_page: 0
                        },
                        list: [],
                        loading: false
                    },
                    hongkongrental: {
                        page: {
                            next_page: 0
                        },
                        list: [],
                        loading: false
                    },
                    studentapartment: {
                        page: {
                            next_page: 0
                        },
                        list: [],
                        loading: false
                    }
                })
                return false
            }
            let count = data.data.count;
            this.searchdata = data.data.searchdata;
            for (let i in data.data.count) {
                if (data.data.count[i] == 0) {
                    this.data[i].page.next_page = 0;
                } else {
                    this.data[i].page.next_page = 1;
                }
            }
            this.setData({
                search: true,
                otherrental: this.data.otherrental,
                studentapartment: this.data.studentapartment,
                hongkongrental: this.data.hongkongrental,
                loading: false,
                kw: data.data.keyword
            })
            this.getDatas()
        }).catch(res => {})

    },

    // 搜索初始化 新的 自动覆盖上面的
    searchKW() {
        // 特殊处理
        if (this.data.isAskingSearch) {
            this.askingHousingSearch()
            return
        }

        miucms.wxget(`${app.globalData.baseURL}/tenement/v2/api/search`, {
            'keyword': this.data.kw
        }).then(res => {
            if (res.code != 200) return
            let data = res.data
            let arr = ['personal', 'intermediary', 'studentapartment']
            for (let i = 0; i < arr.length; i++) {
                let element = arr[i]
                let count = data[element]['count']
                if (count > 0) {
                    this.setData({
                        tab: element
                    })
                    break;
                }

            }

            this.setData({
                ...data
            })
            this.getResultList()
        })
    },

    // 请求结果列表
    requestData: {}, // 请求结果参数
    getResultList() {
        let tab = this.data.tab
        let tabData = this.data[tab]
        if (tabData['page'] == 0 || this.data.resultListLoad) return

        wx.showLoading({
            title: "加载中..."
        })

        this.setData({
            resultListLoad: true
        })

        let searchid = tabData['searchid']
        let url = tab == 'studentapartment' ? `${ app.globalData.baseURL }/tenement/v2/api/apartment` : `${ app.globalData.baseURL }/tenement/v2/api/lists`

        let requestData = {
            // limit: 200,
            ...this.requestData,
            searchid,
            page: tabData['page'] || 1,
        }
        miucms.request(url, requestData).then(res => {
            if (res.code != 200) return
            let data = res.data

            let concreteData = data.data
            if (concreteData) this.handleDetailData(concreteData)

            tabData['page'] = data.page * data.limit >= data.count ? 0 : data.page + 1
            tabData['count'] = data.count
            this.setData({
                search: true,
                [tab]: tabData,
            })
        }).finally(() => {
            this.setData({
                resultListLoad: false
            })
            wx.hideLoading()
        })
    },

    // 获取地域列表
    getLocationList() {
        let that = this;
        miucms.request(app.globalData.config.lists.region, {}).then(data => {
            this.data.location.data = data.data.location;
            this.data.types.data = data.data['type'];
            if (!this.data.isAskingSearch) this.data.school.list = data.data.school
            else this.data.school = null
            that.setData({
                location: that.data.location,
                types: that.data.types,
                property: data.data.property,
                school: that.data.school
            })

            wx.hideLoading()
        }).catch(res => {})
    },

    // 求房源的中介搜索
    askingHousingSearch() {
        let asking = this.data.asking
        if (asking['page'] == 0) return

        let requestData = {
            keyword: this.data.kw,
            ...this.requestData,
            page: asking['page'] || 1,
            intermediary: 6,
        }

        let url = `${app.globalData.baseURL}/tenement/v2/api/lists`

        miucms.request(url, requestData).then(res => {
            if (res.code != 200) return
            let data = res.data
            let concreteData = data.data
            if (concreteData) this.handleDetailData(concreteData)

            asking['page'] = data.page * data.limit >= data.count ? 0 : data.page + 1
            asking['count'] = data.count
            this.setData({
                search: true,
                asking,
            })

        })
    },

    // 新筛选 的 整合中转
    submitOperations(e) {
        let requestData = this.requestData
        requestData = Object.assign(requestData, e.detail)
        let type = requestData['type']

        this.data[this.data.tab].page = 1
        this.data[this.data.tab].list = null
        this.data[this.data.tab].count = 0
        this.data.isUpdateData = true
        this.requestData = requestData

        if (type == "floor") {
            requestData["roomlistings"] = requestData['value']
            this.data.roomlistings.value = requestData['value']
        } else if (type == "house") {
            requestData["roomtype"] = requestData['value']
            this.data.roomtype.value = requestData['value']
        } else if (type == "brand") {
            requestData["brand"] = requestData['value']
            this.data.brands.value = requestData['value']
        }
        if (this.data.isAskingSearch) {
            this.data.asking = {
                data: [],
                page: 1
            }
            this.askingHousingSearch()
        } else this.getResultList()

        this.setData({
            brands: this.data.brands,
            roomtype: this.data.roomtype,
            roomlistings: this.data.roomlistings,
        })

    },

    //  清空
    clearKW() {
        this.setData({
            kw: '',
            focus: true
        })
    },

    // 更换tab
    changeTab(e) {
        let tab = e.currentTarget.dataset.tab
        if (tab == this.data.tab || this.data.resultListLoad) return
        let operationstypeObj = this.data.operationstypeObj
        this.setData({
            tab,
            operationstype: operationstypeObj[tab]
        })

        if (this.data.isUpdateData) { // 处理筛选后并切换tab 是需要刷新数据
            let obj = {
                count: 0,
                searchid: this.data[tab]['searchid']
            }
            this.data[tab] = obj
            this.data.isUpdateData = false
        }

        // 如果当前tab下数量为0 ，则不再加载
        if (this.data[tab].page == 0 || this.data[tab].list) return false;

        // this.getKWdata()
        this.getResultList()


    },
    // 搜索相关tab关键词
    getDatas() {
        let tab = this.data.tab;
        // 如果当前tab下数量为0 ，则不再加载
        if (!this.data[tab].page.next_page) return false;

        this.getKWdata()
    },
    getKWdata() {
        let urlObj = {
            otherrental: app.globalData.config.search.otherrental,
            // hongkongrental: app.globalData.config.search.hongkongrental,
            hongkongrental: `${app.globalData.baseURL}/tenement/housingresources/lists`,
            studentapartment: app.globalData.config.search.studentapartment,
        }
        let tab = this.data.tab;
        let url = urlObj[tab];
        this.data[tab].loading = true;
        this.setTabData()
        miucms.request(url, {
            'searchdata': this.searchdata,
            page: this.data[tab].page.next_page
        }).then(data => {
            this.data[tab].list = this.data[tab].list.concat(data.data.data);
            this.data[tab].loading = false;

            if (data.data.data.length > 0) {
                this.data[tab].page.next_page += 1;
            } else {
                this.data[tab].page.next_page = 0;
            }
            this.setTabData()
        }).catch(res => {})
    },
    // 点击广告
    clickAD(e) {
        miucms.clickAD(e.detail.id)
    },
    // 关闭广告
    closeAD(e) {
        let index = e.currentTarget.dataset.index;
        let tab = e.currentTarget.dataset.tab;

        this.data[tab].list.splice(index, 1)
        if (tab == 'hongkongrental') {
            this.setData({
                hongkongrental: this.data.hongkongrental
            })
        } else {
            this.setData({
                otherrental: this.data.otherrental
            })
        }

        miucms.closeAD(e.detail.id)
    },

    // 获取筛选条件
    getfilterConditions() {
        let that = this;
        miucms.request(app.globalData.config.studentapartment.filterConditions, {}).then(data => {
            wx.hideLoading()
            if (data.code != 200) {
                wx.showModal({
                    title: '提示',
                    content: data.message,
                })
            } else {
                data.data.brand.forEach(item => {
                    item.value = item.id;
                    that.data.brands.obj[item.id] = item.name;
                })
                that.data.brands.list = [{
                    value: '',
                    name: '全部品牌'
                }, ...data.data.brand];

                data.data.roomtype.forEach(item => {
                    item.value = item.id;
                    that.data.roomtype.obj[item.id] = item.name;
                })
                that.data.roomtype.list = [{
                    value: '',
                    name: '全部房型'
                }, ...data.data.roomtype];


                data.data.roomlistings.forEach(item => {
                    item.value = item.id;
                    that.data.roomlistings.obj[item.id] = item.name;
                })
                that.data.roomlistings.list = [{
                    value: '',
                    name: '全部楼型'
                }, ...data.data.roomlistings];


                let schoolObj = {}
                data.data.school.forEach(item => {
                    schoolObj[item.id] = item.name
                })

                this.setData({
                    schoolObj,
                    schoolList: data.data.school,
                    brands: this.data.brands,
                    roomtype: this.data.roomtype,
                    roomlistings: this.data.roomlistings
                })

            }
        }).catch(res => {})
    },

    // 公共跳转
    publicJumps(e) {
        let url = e.currentTarget.dataset.url
        wx.navigateTo({
            url,
        })
    },
})