const miucms = require("../../utils/miucms")
const app = getApp()
// template/choiceTypeRelease/choiceTypeRelease.js
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        identityList: Array,
        choiceTypeState: Boolean,
        housingnum: Number,
    },

    /**
     * 组件的初始数据
     */
    data: {
        popType: "choice", // choice  agent: 确认是否是中介（有个人房源）  affirmAgent: 确认是否是中介（有中介房源）
        identityKey: 0,
        agent: [{
            content: `中介账号发布的房源信息，均展示在“<span style="color: #000; font-weight:650;">中介房源</span>”频道中，即不能发布“<span style="color: #000; font-weight:650;">个人房源</span>”、“<span style="color: #000; font-weight:650;">求房源</span>”；如您已上架个人房源或求房源信息，在你确认中介身份后，将会自动下架`,
            type: 1,
        }],
        affirmAgent: [{
            content: `个人账号只能发布“<span style="color: #000; font-weight:650;">个人房源</span>”、“<span style="color: #000; font-weight:650;">求房源</span>”，在您确认不是中介身份后，将会自动下架您的中介房源；`,
            type: 1,
        }, {
            content: `中介账号只能发布“<span style="color: #000; font-weight:650;">中介房源</span>”，如您已上架个人房源或求房源信息，在你确认中介身份后，将会自动下架；`,
            type: 1,
        }],
        rulesList: [{
            content: `中介账号（未认证）最多可同时上架 <span style="color: #000; font-weight:650;">3</span> 条房源信息`,
            type: 1,
        }, {
            content: `中介账号（有认证）最多可同时上架 <span style="color: #000; font-weight:650;">20</span> 条房源信息`,
            type: 1,
        }, {
            content: `中介帐号（有认证）拥有搜索、过滤“<span style="color: #000; font-weight:650;">求房源</span>”信息的功能`,
            type: 1,
        }],
        showList: [], //展示的规则
    },

    /**
     * 组件的方法列表
     */
    methods: {
        // 关闭弹窗
        closePop() {
            this.setData({
                popType: "choice"
            })
            this.triggerEvent("setValue", {
                key: "choiceTypeState",
                value: false
            })
        },
        setValue(e) {
            let dataset = e.target.dataset
            this.triggerEvent("setValue", dataset)
        },

        choiceItem(e) {
            let key = e.currentTarget.dataset.key
            this.data.identityKey = key
            let popType
            let showList = []
            let rulesList = this.data.rulesList
            let agent = this.data.agent
            let affirmAgent = this.data.affirmAgent
            let housingnum = this.data.housingnum
            if (key == 1) {
                popType = "agent"
                showList = [...agent, ...rulesList]
            } else {
                showList = [...affirmAgent, ...rulesList]
                if (housingnum == 0) this.overallJump()
                else popType = "affirmAgent"
            }

            this.setData({
                popType,
                showList
            })
        },

        // 整体的判断要跳转的哪里
        overallJump() {
            let miniProgram = app.globalData.miniProgram
            let identityKey = this.data.identityKey
            let url
            if (identityKey == 6) url = "/pages/askHousing/askHousing"
            else url = `/pages/edit/edit?intermediary=${identityKey}`
            if (miniProgram == 'xg') {
                wx.navigateTo({
                    url,
                })
            } else {
                wx.navigateToMiniProgram({
                    appId: "wx9c68fbf7886ea9c4",
                    path: url
                })
            }

        },


        // 返回选择  重新选择
        backChoice() {
            this.setData({
                popType: "choice"
            })
        },

        // 确认是中介
        confirmIntermediary(e) {
            let isintermediary = e.currentTarget.dataset.isintermediary
            if (isintermediary == 1) this.data.identityKey = 1
            this.overallJump()

            miucms.request(`${app.globalData.baseURL}/tenement/v2/api/publish/submitidentity`, {
                isintermediary
            }).then(res => {
                if (res.code != 200) return
                app.globalData.user.identity = isintermediary
            })

        },

    }
})