// template/commonList/commonList.js
let app = getApp()
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        item: {
            type: Object,
            observer: res => {}
        },
        index: Number,
        iscollect: Boolean,
        ispublish: Boolean,
        stateData: {
            type: Object,
            observer: function (res) {}
        },
        school: String, // 筛选的 学校值
        isShowVideo: Boolean,
    },

    /**
     * 组件的初始数据
     */
    data: {
        bgColorObj: app.globalData.bgColorObj
    },

    /**
     * 组件的方法列表
     */
    methods: {
        goShow(e) {
            let uniqid = e.currentTarget.dataset.uniqid
            let status = e.currentTarget.dataset.status

            if (status != 1) {
                wx.showModal({
                    title: '提示',
                    content: '该房源信息已出租或已失效',
                })
                return
            }
            let url = `/pages/show/show?uniqid=${uniqid}`
            const school = this.data.school
            console.log("school",school);
            if (school) url += `&school=${school}`

            wx.navigateTo({
                url,
                fail: function (err) {
                    if (err['errMsg'] == "navigateTo:fail webview count limit exceed") {
                        wx.redirectTo({
                            url,
                        })
                    }
                }
            })
        },

        // 取消收藏
        collectOperation(e) {
            let target = e.target.dataset
            this.triggerEvent("collectOperation", target)
        },

        // 上架和下架
        undercarriage(e) {
            let target = e.target.dataset
            target['type'] = 'undercarriage'
            this.triggerEvent("userOperation", target)
        },

        // 编辑
        judgeEditSkip(e) {
            let url = e.target.dataset.url
            // 编辑上架情况 回来要更新数据
            if (this.data.stateData['btn'] == 1) app.globalData.editShelfState = "update"

            let miniProgram = app.globalData['miniProgram']
            if (miniProgram == 'gx') {
                wx.navigateToMiniProgram({
                    appId: "wx9c68fbf7886ea9c4",
                    path: url
                })
            } else {
                wx.navigateTo({
                    url
                })
            }
        },

        // 删除
        del_item(e) {
            let target = e.target.dataset
            target['type'] = 'del'
            this.triggerEvent("userOperation", target)
        },

        // 顶上去
        goUp(e) {
            let target = e.target.dataset
            target['type'] = 'up'
            this.triggerEvent("userOperation", target)
        },
    }
})