// template/fixFooter/fixFooter.js
var miucms = require('../../utils/miucms.js');

let app = getApp()
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        user: Number,
        unreadMessages: {
            type: Number,
            value: 0
        },
        bottomLift: {
            type: Number
        },
    },

    /**
     * 组件的初始数据
     */
    data: {
        // unreadMessages: 0
        isAuthorization: 0,
        identityList: [],
        choiceTypeState: false,
    },

    lifetimes: {},

    /**
     * 组件的方法列表
     */
    methods: {
        // 发布房源 的 判断
        judgeIssue() {
            // 是否有规则数据
            if (this.data.identityList.length != 0) {
                this.setData({
                    choiceTypeState: true
                })
                return
            }
            miucms.request(`${app.globalData.baseURL}/tenement/v2/api/publish/checkidentity`).then(res => {
                if (res.code == 401) {
                    this.setData({
                        isAuthorization: 1
                    })
                    return
                }
                if (res.code != 200) return
                let data = res.data
                let identityList = data.data
                let isintermediary = data.isintermediary
                if (data['ispopup'] == 0) {
                    // if (data['ispopup'] == 1) {
                    let miniProgram = app.globalData.miniProgram
                    let url = `/pages/edit/edit?intermediary=${isintermediary}`
                    if (miniProgram == 'xg') {
                        wx.navigateTo({
                            url,
                        })
                    } else {
                        wx.navigateToMiniProgram({
                            appId: "wx9c68fbf7886ea9c4",
                            path: url
                        })
                    }
                    return
                }
                this.setData({
                    identityList,
                    housingnum: data.housingnum,
                    isintermediary,
                    ispopup: data.ispopup,
                    choiceTypeState: true,
                })
            })
        },

        // 处理发布房源 判断是否有用户名
        handleIssue() {
            let user = app.globalData['user']
            if (user['uid']) {
                if (!user['nickname'] || !user['avatar']) {
                    wx.navigateTo({
                        url: '/pagesLoginRequired/pages/setAvatarNickname/setAvatarNickname',
                    })
                    return
                } else this.judgeIssue()
            } else {
                this.setData({
                    isAuthorization: 1
                })
            }
        },

        setValue(e) {
            let {
                key,
                value
            } = e.detail
            this.setData({
                [key]: value
            })
        }
    }
})