// template/headerNav/index.js
var app = getApp()
Component({
    options: {
        multipleSlots: true,
    },
    /**
     * 组件的属性列表
     */
    properties: {
        isNoNeedHolder: Boolean, // 是否不需要 占位 元素 
        notShowIndex: Boolean, // 是否 展示返回首页按钮
        isIndexPage: Boolean,
        haveSearch: Boolean,
        customBack: Boolean,
        isMessageCount: Boolean,
        isMessage: Boolean,
        topImage: Boolean,
        unreadMessages: Number, // 展示信息数量
        bgcolor: String, // 背景颜色
        position: String, // css 定位方式
        headerSrc: String, // 首页的右上角图标
        backSrc: String, //  特殊的返回图标
        borderBottom: Boolean,

        showTab: String, // 需要显示的 列表按钮  
        newHeadOperate: Boolean, // 是否是 新的 二级页面 顶部 返回按钮
        operationsTop: Boolean, // 是否 滚动了 不需要顶部颜色

    },

    /**
     * 组件的初始数据
     */
    data: {
        screen_data: {
            windowHeight: 0,
            totalTopHeight: 0,
            statusBarHeight: 0,
            titleBarHeight: 0,
        },
        isTabPage: false,
        openDate: {}, // 开屏广告数据
        showTabObj: {
            person: "房源列表",
            agent: "房源列表",
            apartment: "公寓列表",
            need: "求房源列表",
        },
    },
    lifetimes: {
        attached: function () {
            this.get_config()
            this.attachedIn()
        },
    },
    attached: function () {
        this.attachedIn()
    },

    /**
     * 组件的方法列表
     */
    methods: {
        get_config() {
            if (app.globalData.initialState) {
                this.handleOpenAd()
            } else setTimeout(() => this.get_config(), 10)
        },

        handleOpenAd() {
            const offerkaipingadvertisement = app.globalData.offerkaipingadvertisement
            const offerkaipingadvertisementState = app.globalData.offerkaipingadvertisementState
            if (!offerkaipingadvertisementState) {
                let data = offerkaipingadvertisement || {}
                // if (Date.now() < data.deadline * 1000) {
                this.setData({
                    openDate: data
                })
                // }
            }
        },

        attachedIn() {
            if (app.globalData.screen_data.totalTopHeight > 30) {
                this.data.screen_data = app.globalData.screen_data;
                this.data.screen_data.index = false;
                this.setData({
                    screen_data: app.globalData.screen_data
                })
            } else {
                try {
                    app.computeNavigateBarHeight();
                } catch (e) {
                    // 获取系统信息失败
                    this.setData({
                        windowHeight: 812,
                        totalTopHeight: 68,
                        statusBarHeight: 20,
                        titleBarHeight: 48,
                        titleWidth: 87
                    });
                }
            }

        },
        backHome() {
            wx.reLaunch({
                url: `/pages/index/index`,
            })
        },
        navigategoBack() {
            var pages = getCurrentPages();
            if (this.properties.customBack) {
                this.triggerEvent('back', {}, {})
                return false;
            }
            if (pages.length == 1) {
                wx.reLaunch({
                    url: `/pages/index/index`
                });
            } else {
                wx.navigateBack({
                    changed: true
                }); //返回上一页
            }
        },
        // 跳转消息页面
        goMessageCenter() {
            this.triggerEvent('unreadMessagesalter')
        },

        // 跳转发布系统消息页面
        goIsMessage() {
            this.triggerEvent("goIsMessage")
        },
        // 头部 跳转 中转
        skipTransfer(e) {
            const key = e.currentTarget.dataset.key
            const pages = getCurrentPages();
            if (key == 'back' && pages.length > 1) {
                wx.navigateBack()
                return
            }

            let url = ''
            if (key == 'index' || key == 'back') url = '/pages/index/index'
            if (key == 'person') url = '/pages/personList/personList'
            if (key == 'agent') url = '/pages/agentList/agentList'
            if (key == 'apartment') url = '/pages/brandApartmentList/brandApartmentList'
            if (key == 'need') url = '/pages/needHousing/needHousing'
            wx.navigateTo({
                url,
            })
        },
    }
})